#ifndef _video_H
#define _video_H

#include <glib.h>
#include <directfb.h>

typedef struct {
	IDirectFB *dfb;                         /** our directfb object */
	IDirectFBImageProvider *provider;       /** foo */
	IDirectFBSurface *surface;              /** our image holder */
        IDirectFBInputDevice *keyboard;         /** our main input dev */
        IDirectFBEventBuffer *ev_buffer;        /** our events listener */
	DFBSurfaceDescription desc;             /** bar */
} splashy_video_t;

/* public functions */
gint video_draw_progressbar(splashy_video_t *video, DFBRectangle *progressbar);
gint video_update_progressbar(splashy_video_t *video, DFBRectangle *progressbar, gint perc);
void video_start_splash(splashy_video_t *video, const gchar *background);
void video_change_splash(splashy_video_t *video, const gchar *newimage);
void video_set_mode(splashy_video_t *video);
void video_allow_vt_switching();

#endif
