/************************************************************************
 *                              xml_parser.h                            *
 *                                                                      *
 *  2005-05-28 03:36 EDT                                                *
 *  Copyright  2005  Luis Mondesi <lemsx1@gmail.com>                    *
 ************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _XML_PARSER_H
#define _XML_PARSER_H
#include <glib.h>

#define SPLASHY_CONFIG_FILE "/etc/splashy/config.xml"

/** data structures */

typedef struct _attr {
        GString* name;    /** attribute name */
        GString* value;   /** attribute value */
} SplashyXMLAttr;

typedef struct _node {
	GString* text; /** XML text value, if any */
        GString* name; /** XML tag name */
        gboolean got_attr; /** does this node have attributes ? */
        gboolean got_text; /** does this node have any text? */
        gboolean tag_opened; /** status whether tag is open or close */
        guint depth;       /** how deep into the XML file are we? */
        GList* attrs;      /** list of SplashyXMLAttr for this tag */
} SplashyXMLNode;

typedef struct _xml_config {
        GString* config_path; /** full path to the configuration file */
        GList* priv; /** list of SplashyXMLNode for this config file */
} SplashyConfig;

SplashyConfig* splashy_xml_config; /** global: default config file */

/** public functions */

const gchar* spl_get_text(const gchar* tag);
gint spl_get_int(const gchar* tag, gint base);

#endif /* _XML_PARSER_H */
